<?php

/**
 * FPA.
 *
 * @package Logic
 * @author  alessandrobartels
 *
 */

class FPA {

    const NRORG_PADRAO = 'NRORG_PADRAO';
    const NRORG_TRAB = 'NRORG_TRAB';
    const ESTRUTURA_TRAB = 'ESTRUTURA_TRAB';
    const TIPO_ESTRUTURA_LEGAL = 'TIPO_ESTRUTURA_LEGAL';
    const TIPO_ESTRUTURA_GERENCIAL = 'TIPO_ESTRUTURA_GERENCIAL';
    const MES_COMPETENCIA = 'MES_COMPETENCIA';
    const ULTIMO_DIA_MES = 'ULTIMO_DIA_MES';
    const MOD_CALCULO = 'MOD_CALCULO';
    const MOD_SALARIO = 'MOD_SALARIO';
    const OCORRENCIA_CALCULO = 'OCORRENCIA_CALCULO';
    const TIPO_OPERADOR = 'TIPO_OPERADOR';

    private static $instance;

    private static $opergrupop;
    private static $gpeParamoper;
    private static $gpeParamorg;

    public function __construct() {

    }

    public static function getInstance() {
        if (!self::$instance) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     * Determina numero de calculo de folha.
     *
     * @param string $nrOrg         Numero da Organizacao.
     * @param string $tipoMovimento Tipo de Movimento.
     * @param string $cdOperador    Codigo do operador.
     *
     * @return integer
     */
    public static function determinaNrCalculoFolha($nrOrg, $tipoMovimento, $cdOperador) {

        /* @todo parar de passar org de trabalho e passar a org do $cdOperador
         * alterado abaixo para \Ambiente::getNrorg()
         * Leandro 23/07/2013
         * */
        $parametro = new Parametros(\Ambiente::getNrorg(), $cdOperador);
        $mesCompetencia = $parametro->getMesCompetencia();
        $nrOrgTrabalho = $parametro->getNrOrgTrabalho();
        $nrTpModalidadeCalc = $parametro->getTipoModalidadeCalculo();
        $nrOcorrenciaCalc = $parametro->getNrOcorrenciaCalculo();

        $calculoFolha = new FpacalculofolhaEntity();
        $calcFolha = current(
            $calculoFolha->retornaCalculoFolha(
                $nrOrgTrabalho, $tipoMovimento, $mesCompetencia, $nrTpModalidadeCalc, $nrOcorrenciaCalc
            )
        );

        unset($parametro);
        if(is_object($calcFolha)){
            return $calcFolha->getNrcalculofolha();
        }
        else{
            tk_warning('algum parâmetro do operador faltando.<br /> NRORGOPER:'.$nrOrg.'<br/>cdoperador'.$cdOperador.' <br /> NRORG:'.$nrOrgTrabalho.'<BR />Tipo Movimento:'.$tipoMovimento.'<br />Mês comp.:'.$mesCompetencia.'<br />Tipo modalidade calc:'.$nrTpModalidadeCalc.'<br />Num. Ocorrêcia:'.$nrOcorrenciaCalc);
        }
    }


    /**
     * Constroi string para informacao em tela.
     *
     * @param string $nrOrg      Numero da organizacao.
     * @param string $cdOperador Codigo do operador.
     *
     * @return void
     *
     * @author alessandrobartels - 15/06/2011
     */
    public static function determinaInformacoesTela($nrOrg, $cdOperador){

    }

    public static function getInfo(){
        $info = 'Org: '                .self::getNrorgTrabalho().
          '      Estrutura: '          .self::getEstruturaTrabalho().
          '      Competencia: '        .self::getDtCompetencia().
          '      Ocorrencia: '         .self::getOcorrenciaCalculo().
          '      Modalidade Calculo: ' .self::getModalidadeCalculo().
          '      Modalidade Salario: ' .self::getModalidadeSalario();
        return $info;
    }

    public static function setInfo($nrorgselecionada,$nrestruttrabalho,$competencia,$ocorCalculo,$modalidCalculo,$modalidSalario) {
        $info = 'Org: '                 .$nrorgselecionada.
          '      Estrutura: '           .$nrestruttrabalho.
          '      Competencia: '         .$competencia.
          '      Ocorrencia: '          .$ocorCalculo.
          '      Modalidade Calculo: '  .$modalidCalculo.
          '      Modalidade Salario: '  .$modalidSalario;
        return $info;
    }

    /**
     * Converta parte de minuto da hora em decimal (depois da virgula)
     * @static
     *
     * @param $hora
     *
     * @return float
     */
    public static function converteHoraDecimal($hora){

        $aux = floor($hora);

        if ($aux === $hora){
            return $hora;
        } else {
            $minuto = $hora - $aux;
            $decimal = $minuto * 100.0 / 60.0;
            $aux += $decimal;

            return $aux;
        }
    }

    /**
     * Converta parte decimal da hora em minuto (depois da virgula)
     * @static
     *
     * @param $hora
     *
     * @return float
     */
    public static function converteDecimalHoraMinuto($hora){

        $aux = floor($hora);

        if ($aux === $hora){
            return $hora;
        } else {
            $decimal = $hora - $aux;
             $minuto = $decimal * 60.0 / 100;
            $aux += $minuto;

            return $aux;
        }
    }

    public static function getNrorgTrabalho() {
        $nrorgtrab = \Geral\Util\Ambiente::getNrorgTrabalho();
        //04/06/2014 - Alterada pelo Marcelo. Anteriormente, estava setando o valor de organização
        //             de trabalho para a variavel MESCOMPETENCIA        
        tk_set_env_var('NRORG_TRAB',$nrorgtrab);
        return $nrorgtrab;
    }

    public static function setNrorgTrabalho($nrorgTrabalho) {
        \Geral\Util\Ambiente::getInstancia()->getOperador()->setNrorgtrab($nrorgTrabalho);
        \Geral\Util\Ambiente::getInstancia()->getOperador()->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function getTipoEstruturaLegalOrg() {
        return self::getGpeParametrosOrganizacao()->getNrtpestrutlegal();
    }

    public static function getTipoEstruturaGerencialOrg() {
        return self::getGpeParametrosOrganizacao()->getNrtpestrutgeren();
    }

    public static function getDtCompetencia() {
        $aux = self::getGpeParametrosOperador()->getDtmescompetenc().'';
        $dat = date("m/d/Y", strtotime($aux));
        tk_set_env_var('MES_COMPETENCIA',$dat);
        return $dat;
    }

    public static function getCompetenciaOrg() {
        return ''.self::getGpeParametrosOrganizacao()->getDtcompetencia();
    }

    /**
     *Retorna a data de competencia para o operador logado
     *se o operador usar data de competencia da org ela sera retornada
     *caso nao use a data de competencia da org retorna a data de competencia do operador.
     */
    public static function getCompetencia() {
        if(!self::getCompetenciaOrg()){
            return self::getDtCompetencia();
        }
        return self::getCompetenciaOrg();
    }

    public static function getEstruturaTrabalho() {
        return \Geral\Util\Ambiente::getInstancia()->getOperador()->getNrestruttrab();
    }

    public static function getUltimoDiaMes() {
        $dtcomporg = new TkDateTime(self::getDtCompetencia());
        $dtcomporg->setDay(1)->addMonth(1)->subDay(1);
        return $dtcomporg->get('dd/MM/yyyy');
    }
    public static function getOcorrenciaCalculo() {
        return self::getGpeParametrosOperador()->getNrocorrecal();
    }

    public static function getModalidadeCalculo() {
        return self::getGpeParametrosOperador()->getTpmodalidcal()->getNmtpmodalidcal();
    }
    
    public static function getNrModalidadeCalculo() {
        return self::getGpeParametrosOperador()->getTpmodalidcal()->getNrtpmodalidcal();
    }

    public static function getModalidadeSalario() {
        return self::getGpeParametrosOperador()->getTpmodalidsal()->getNmtpmodalidsal();
    }

    public static function getNrModalidadeSalario() {
        return self::getGpeParametrosOperador()->getTpmodalidsal()->getNrtpmodalidsal();
    }

    public static function getNrorgPadrao() {
        return self::getGpeParametrosOrganizacao()->getNrorgpadrao();
    }

    /**
     * @return \Geral\Entities\Opergrupop[]
     */
    public static function getOpergrupop() {
        if (!self::$opergrupop) {
            self::$opergrupop = \Geral\Entities\Opergrupop::findByNrorgAndCdoperador(
                \Geral\Util\Ambiente::getNrorg(),
                \Geral\Util\Ambiente::getInstancia()->getOperador()->getCdoperador()
            );
        }
        return self::$opergrupop;
    }

    /**
     * @return \Geral\Entities\GpeParamoper
     */
    public static function getGpeParametrosOperador() {
        if (!self::$gpeParamoper) {

            self::$gpeParamoper = \Geral\Entities\GpeParamoper::findOneByNrorgAndCdoperador(
                    \Ambiente::getNrorgoper(), \Geral\Util\Ambiente::getCdOperador()
            );
        }
        return self::$gpeParamoper;
    }

    /**
     * @return \Folha\Entities\GpeParamorg
     */
    public static function getGpeParametrosOrganizacao() {
        if (!self::$gpeParamorg) {
            self::$gpeParamorg = \Folha\Entities\GpeParamorg::findOneByNrorg(\Geral\Util\Ambiente::getNrOrgTrabalho());
        }
        return self::$gpeParamorg;
    }

    /**
     * Gera arquivo das obrigações legais
     * @static
     *
     * @param $pasta
     * @param $nomeArquivo
     * @param $extensao
     * @param int $permissao
     * @return objeto do arquivo TkFile
     *
     * @autor Leonardo Carvalho
     */
    public static function geraArquivo($pasta, $nomeArquivo, $extensao, $permissao = 0777) {
        if (empty($extensao)) {
            tk_warning("Extensão inválida.");
        }
        else if (empty($nomeArquivo)) {
            tk_warning("Nome do arquivo inválido.");
        }
        else if (empty($pasta)) {
            tk_warning("Nome da pasta inválida.");
        } else {
            $caminho = __DIR__."/../../../source/fpa/public/".\FPA::getNrorgTrabalho();
            $mimeType = "AddType application/octet-stream ".$extensao;

            if(!file_exists($caminho.'/'.$pasta)) {
                @mkdir($caminho);
                mkdir($caminho.'/'.$pasta);
                chmod($caminho,$permissao);
                chmod($caminho.'/'.$pasta,$permissao);
                file_put_contents($caminho.'/'.$pasta.'/.htaccess',$mimeType);
                chmod($caminho.'/'.$pasta.'/.htaccess',$permissao);
            }

            //objeto para criar o arquivo
            $arquivo = new TkFile($caminho.'/'.$pasta.'/'.$nomeArquivo, true);

            return $arquivo;
        }
    }

    public static function labelDinamicoTabEstrutura($opcao){
        switch ($opcao){
            case 2:
                $label = 'Filial'; break;
            case 7:
                $label = 'Tomador';  break;
            case 10:
                $label = 'Sindicato';  break;
        }

        tk_set_tab_label($label);
    }

    public static function getOperadorCorrente($tabela){
        if($tabela=='GPE_ORGRELOPER'){
            tk_warning(' GPE_ORGRELOPER.CDOPERADOR='. \Ambiente::getCdOperador().' AND GPE_ORGRELOPER.NRORGOPER='.\Ambiente::getNrorg());
            return ' GPE_ORGRELOPER.CDOPERADOR='. \Ambiente::getCdOperador().' AND GPE_ORGRELOPER.NRORGOPER='.\Ambiente::getNrorg();
        }

        return ' '.$tabela.'.CDOPERADOR='. \Ambiente::getCdOperador().'  AND '.$tabela.'.NRORG='.\Ambiente::getNrorg();

    }

    public static function getRestConfidencial(){
        foreach(self::getOpergrupop() as $grupo){
            if($grupo->getCdgrupoper()=='00'){
                return 'N';
            }
        }
        return 'S';
    }

    public static function setUserInfo()
    {
        $dtmescompetencia = new TkDateTime(FPA::getDtCompetencia());

        $nmoperador     = \Geral\Util\Ambiente::getNmOperador();
        $nrorgTrabalho  = FPA::getNrorgTrabalho();
        $nrocorrencia   = FPA::getOcorrenciaCalculo();
        $modalidadeCalc = FPA::getModalidadeCalculo();
        $modalidadeSal  = FPA::getModalidadeSalario();

        /** @var $organizacao OrganizacaoEntity */
        $organizacao = OrganizacaoEntity::getEntityByWhere('NRORG = ?', array($nrorgTrabalho));
        if (is_object($organizacao)) {
            $nmorganizacao = '/ '.$organizacao->getNmorganizacao();
        }
        $nrestruturaTrabalho = FPA::getEstruturaTrabalho();
        if ($nrestruturaTrabalho) {
            /** @var $estrutura EstruturahEntity */
            $estruturah = EstruturahEntity::getEntityByWhere(
                "NRORG = ? AND NRESTRUTURAM = ? AND DTMESCOMPETENC <= ?",
                array($nrorgTrabalho, $nrestruturaTrabalho, $dtmescompetencia->get('dd/MM/YYYY'))
            );
        } else {
            $nrestruturaTrabalho = '(vazia)';
        }

        if (is_object($estruturah)) {
            $nmestrutura = '/ '.($estruturah->getNmestruturah()) ? : $estruturah->getNmfantasia();
        }

        $style = "<style>.subParent #muserinfo\:result .ambiente-top{margin-top:5px !important;} .subParent #muserinfo\:result{width:auto !important;height:auto !important;}</style>";
        tk_set_user_info("$style
<style>.subParent #muserinfo\:result .ambiente-top{margin-top:5px !important;} .subParent #muserinfo\:result{width:auto !important;height:auto !important;}</style>
<pre style='overflow: hidden'>
<div class=\"formContent cols-8-8 newline\">
<strong>Dados do Operador</strong>
Operador:        @\Geral\Util\Ambiente::getNmOperador()@
Organização:     @FPA::getNrorgTrabalho()@ @\Geral\Util\Ambiente::getOrganizacao()->getNmorganizacao()@
Estrutura:       @\Geral\Util\Ambiente::getInstancia()->getOperador()->getEstruttrab()->getNrestruturam()@
Mês Competência: @FPA::getDtCompetencia()@

<strong>Parâmetros de Cálculo</strong>
Ocorrência:            @FPA::getOcorrenciaCalculo()@
Modalidade de Cálculo: @FPA::getModalidadeCalculo()@
Modalidade de Salário: @FPA::getModalidadeSalario()@
</div>
<div class=\"formContent cols-4-8 field button newline\">
    <input
        type=\"button\"
        value=\"Alterar Senha\"
        onclick=\"Framework.callMenuClick('gpe_alterasenha', undefined, true); return false;\">
</div>
<div class=\"formContent cols-4-8 field button sameline\">
    <input
        type=\"button\"
        value=\"Alterar Parâmetros\"
        onclick=\"Framework.callMenuClick('gpe_paramoper', undefined, true); return false;\">
</div>
</pre>
        ");

    }


    public static function selecionaFiltroEstruturaTrabalho($nomeTabela, $nrOrgTrab, $nrEstrutTrab){
        if (empty($nrEstrutTrab) === true) {
            $resultado = $nomeTabela.'.NRORG = '.$nrOrgTrab;
        } else {
            $resultado = $nomeTabela.'.NRORG = '.$nrOrgTrab.' AND '.$nomeTabela.'.NRESTRUTLEGAL = '.$nrEstrutTrab;
        }

        return $resultado;
    }

    /**
     * Determina data de alteracao salarial.
     *
     * @param string $nrorg Numero da Organizacao.
     *
     * @return TkDateTime
     */
    public static function determinaDataAlteracaoSalarial($nrorg){
        //$parametro = new Parametros();
        //$data = $parametro->dataAlteracaoSalarial($nrorg);
        //return $data;
        return null;
    }
}
/* Fim de arquivo.*/