CREATE OR REPLACE PROCEDURE GRAVA_ENDPART_SPED_ORCLANT
AS
   V_DSCODPART    VARCHAR2(400);
   V_PARTICIPANTE VARCHAR2(4000);
BEGIN
   DELETE FROM ENDPARTSPED;
   V_DSCODPART    := NULL;
   V_PARTICIPANTE := NULL;
   FOR C_DADOS IN (SELECT PARTICIPANTE, INSCRICAO, PAIS, ESTADO, MUNICIPIO, ENDERECO, NUMERO, COMPLEMENTO, BAIRRO,
                          INSCRICAO||PAIS||ESTADO||MUNICIPIO||ENDERECO||NUMERO||COMPLEMENTO||BAIRRO AS DSCODPART
                     FROM (SELECT 'C'||CL.CDCLIENTE AS PARTICIPANTE, CL.NRINSJURCLIE AS INSCRICAO, EC.CDPAIS AS PAIS, EC.SGESTADO AS ESTADO, EC.CDMUNICIPIO AS MUNICIPIO,
                                  NVL(EC.DSENDECLIESEP,EC.DSENDECLIE) AS ENDERECO, EC.NRENDECLIESEP AS NUMERO,
                                  EC.DSCOMPENDCLI AS COMPLEMENTO, EC.NMBAIRCLIE AS BAIRRO
                             FROM CLIENTE CL, ENDECLIE EC
                            WHERE CL.CDCLIENTE = EC.CDCLIENTE
                              AND CL.IDENDEMISCLI = EC.IDTPENDECLIE
                            UNION ALL
                           SELECT 'F'||FO.CDFORNECED AS PARTICIPANTE, FO.NRINSJURFORN AS INSCRICAO, EF.CDPAIS AS PAIS, EF.SGESTADO AS ESTADO, EF.CDMUNICIPIO AS MUNICIPIO,
                                  NVL(EF.DSENDEFORNSEP,EF.DSENDEFORN) AS ENDERECO, EF.NRENDEFORNSEP AS NUMERO,
                                  EF.DSCOMPENDFOR AS COMPLEMENTO, EF.NMBAIRFORN AS BAIRRO
                             FROM FORNECEDOR FO, ENDEFORN EF
                            WHERE FO.CDFORNECED = EF.CDFORNECED
                              AND FO.IDENDEMISFOR = EF.IDTPENDEFORN
                            UNION ALL
                           SELECT 'L'||FI.CDFILIAL AS PARTICIPANTE, FI.NRINSJURFILI, DECODE(FI.IDENDEMISFIL,'I',I.CDPAIS,EF.CDPAIS) AS CDPAIS,
                                  DECODE(FI.IDENDEMISFIL,'I',I.SGESTADO,EF.SGESTADO) AS ESTADO,
                                  DECODE(FI.IDENDEMISFIL,'I',I.CDMUNICIPIO,EF.CDMUNICIPIO) AS MUNICIPIO,
                                  DECODE(FI.IDENDEMISFIL,'I',NVL(I.DSENDEIESTSEP,I.DSENDEIEST),NVL(EF.DSENDEFILISEP,EF.DSENDEFILI)) AS ENDERECO,
                                  DECODE(FI.IDENDEMISFIL,'I',I.NRENDEIESTSEP,EF.NRENDEFILISEP) AS NUMERO,
                                  DECODE(FI.IDENDEMISFIL,'I',I.DSCOMPENDIES,EF.DSCOMPENDFIL) AS COMPLEMENTO,
                                  DECODE(FI.IDENDEMISFIL,'I',I.NMBAIRIEST,EF.NMBAIRFILI) AS BAIRRO
                             FROM FILIAL FI, ENDEFILI EF, INSCRESTAD I
                            WHERE EF.CDFILIAL        = FI.CDFILIAL
                              AND ((EF.IDTPENDEFILI  = NVL(FI.IDENDEMISFIL,'P')) OR (FI.IDENDEMISFIL = 'I' AND EF.IDTPENDEFILI = 'P'))
                              AND FI.CDINSCESTA      = I.CDINSCESTA
                              AND FI.CDEMPRESA       = I.CDEMPRESA)
                    ORDER BY INSCRICAO, PAIS, ESTADO, MUNICIPIO, ENDERECO, NUMERO, COMPLEMENTO, BAIRRO) LOOP

	   IF (V_DSCODPART IS NULL) OR (V_DSCODPART <> C_DADOS.DSCODPART) THEN
	      INSERT INTO ENDPARTSPED
		     (INSCRICAO, PAIS, ESTADO, MUNICIPIO, ENDERECO, NUMERO, COMPLEMENTO, BAIRRO, PARTICIPANTE)
		  VALUES
		     (C_DADOS.INSCRICAO, C_DADOS.PAIS, C_DADOS.ESTADO, C_DADOS.MUNICIPIO, C_DADOS.ENDERECO,
			  C_DADOS.NUMERO, C_DADOS.COMPLEMENTO, C_DADOS.BAIRRO, C_DADOS.PARTICIPANTE);
	      V_PARTICIPANTE := C_DADOS.PARTICIPANTE;
	      V_DSCODPART    := C_DADOS.DSCODPART;
	   ELSE
	      UPDATE ENDPARTSPED
		     SET PARTICIPANTE = PARTICIPANTE || '_' || C_DADOS.PARTICIPANTE
		   WHERE PARTICIPANTE = V_PARTICIPANTE;
		  V_PARTICIPANTE := V_PARTICIPANTE || '_' || C_DADOS.PARTICIPANTE;
	   END IF;

   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_ENDPART_SPED_ORCLANT','0.00.000'); END;
/


